/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSEventException.h"

#include "EventException.h"
#include "ExceptionCode.h"
#include "JSDOMBinding.h"
#include "URL.h"
#include <runtime/Error.h>
#include <runtime/JSString.h>
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSEventExceptionTableValues[] =
{
    { "code", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEventExceptionCode), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "name", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEventExceptionName), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "message", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEventExceptionMessage), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEventExceptionConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSEventExceptionTable = { 10, 7, true, JSEventExceptionTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSEventExceptionConstructorTableValues[] =
{
    { "UNSPECIFIED_EVENT_TYPE_ERR", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEventExceptionUNSPECIFIED_EVENT_TYPE_ERR), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "DISPATCH_REQUEST_ERR", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEventExceptionDISPATCH_REQUEST_ERR), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSEventExceptionConstructorTable = { 4, 3, true, JSEventExceptionConstructorTableValues, 0 };
static const HashTable& getJSEventExceptionConstructorTable(VM& vm)
{
    return getHashTableForGlobalData(vm, JSEventExceptionConstructorTable);
}

const ClassInfo JSEventExceptionConstructor::s_info = { "EventExceptionConstructor", &Base::s_info, 0, getJSEventExceptionConstructorTable, CREATE_METHOD_TABLE(JSEventExceptionConstructor) };

JSEventExceptionConstructor::JSEventExceptionConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSEventExceptionConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSEventExceptionPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSEventExceptionConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSEventExceptionConstructor, JSDOMWrapper>(exec, getJSEventExceptionConstructorTable(exec->vm()), jsCast<JSEventExceptionConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSEventExceptionPrototypeTableValues[] =
{
    { "UNSPECIFIED_EVENT_TYPE_ERR", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEventExceptionUNSPECIFIED_EVENT_TYPE_ERR), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "DISPATCH_REQUEST_ERR", DontDelete | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsEventExceptionDISPATCH_REQUEST_ERR), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { "toString", DontEnum | JSC::Function, NoIntrinsic, (intptr_t)static_cast<NativeFunction>(jsEventExceptionPrototypeFunctionToString), (intptr_t) (0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSEventExceptionPrototypeTable = { 8, 7, true, JSEventExceptionPrototypeTableValues, 0 };
static const HashTable& getJSEventExceptionPrototypeTable(VM& vm)
{
    return getHashTableForGlobalData(vm, JSEventExceptionPrototypeTable);
}

const ClassInfo JSEventExceptionPrototype::s_info = { "EventExceptionPrototype", &Base::s_info, 0, getJSEventExceptionPrototypeTable, CREATE_METHOD_TABLE(JSEventExceptionPrototype) };

JSObject* JSEventExceptionPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSEventException>(vm, globalObject);
}

bool JSEventExceptionPrototype::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSEventExceptionPrototype* thisObject = jsCast<JSEventExceptionPrototype*>(object);
    return getStaticPropertySlot<JSEventExceptionPrototype, JSObject>(exec, getJSEventExceptionPrototypeTable(exec->vm()), thisObject, propertyName, slot);
}

static const HashTable& getJSEventExceptionTable(VM& vm)
{
    return getHashTableForGlobalData(vm, JSEventExceptionTable);
}

const ClassInfo JSEventException::s_info = { "EventException", &Base::s_info, 0, getJSEventExceptionTable , CREATE_METHOD_TABLE(JSEventException) };

JSEventException::JSEventException(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<EventException> impl)
    : JSDOMWrapper(structure, globalObject)
    , m_impl(impl.leakRef())
{
}

void JSEventException::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSEventException::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSEventExceptionPrototype::create(vm, globalObject, JSEventExceptionPrototype::createStructure(vm, globalObject, globalObject->errorPrototype()));
}

void JSEventException::destroy(JSC::JSCell* cell)
{
    JSEventException* thisObject = static_cast<JSEventException*>(cell);
    thisObject->JSEventException::~JSEventException();
}

JSEventException::~JSEventException()
{
    releaseImplIfNotNull();
}

bool JSEventException::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSEventException* thisObject = jsCast<JSEventException*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSEventException, Base>(exec, getJSEventExceptionTable(exec->vm()), thisObject, propertyName, slot);
}

EncodedJSValue jsEventExceptionCode(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSEventException* castedThis = jsDynamicCast<JSEventException*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    EventException& impl = castedThis->impl();
    JSValue result = jsNumber(impl.code());
    return JSValue::encode(result);
}


EncodedJSValue jsEventExceptionName(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSEventException* castedThis = jsDynamicCast<JSEventException*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    EventException& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.name());
    return JSValue::encode(result);
}


EncodedJSValue jsEventExceptionMessage(ExecState* exec, EncodedJSValue slotBase, EncodedJSValue thisValue, PropertyName)
{
    JSEventException* castedThis = jsDynamicCast<JSEventException*>(JSValue::decode(thisValue));
    UNUSED_PARAM(slotBase);
    if (!castedThis)
        return throwVMTypeError(exec);
    UNUSED_PARAM(exec);
    EventException& impl = castedThis->impl();
    JSValue result = jsStringWithCache(exec, impl.message());
    return JSValue::encode(result);
}


EncodedJSValue jsEventExceptionConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSEventException* domObject = jsDynamicCast<JSEventException*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSEventException::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSEventException::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSEventExceptionConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}

EncodedJSValue JSC_HOST_CALL jsEventExceptionPrototypeFunctionToString(ExecState* exec)
{
    JSValue thisValue = exec->hostThisValue();
    JSEventException* castedThis = jsDynamicCast<JSEventException*>(thisValue);
    if (!castedThis)
        return throwVMTypeError(exec);
    ASSERT_GC_OBJECT_INHERITS(castedThis, JSEventException::info());
    EventException& impl = castedThis->impl();

    JSC::JSValue result = jsStringWithCache(exec, impl.toString());
    return JSValue::encode(result);
}

// Constant getters

EncodedJSValue jsEventExceptionUNSPECIFIED_EVENT_TYPE_ERR(ExecState* exec, EncodedJSValue, EncodedJSValue, PropertyName)
{
    UNUSED_PARAM(exec);
    return JSValue::encode(jsNumber(static_cast<int>(0)));
}

EncodedJSValue jsEventExceptionDISPATCH_REQUEST_ERR(ExecState* exec, EncodedJSValue, EncodedJSValue, PropertyName)
{
    UNUSED_PARAM(exec);
    return JSValue::encode(jsNumber(static_cast<int>(1)));
}

bool JSEventExceptionOwner::isReachableFromOpaqueRoots(JSC::Handle<JSC::Unknown> handle, void*, SlotVisitor& visitor)
{
    UNUSED_PARAM(handle);
    UNUSED_PARAM(visitor);
    return false;
}

void JSEventExceptionOwner::finalize(JSC::Handle<JSC::Unknown> handle, void* context)
{
    JSEventException* jsEventException = jsCast<JSEventException*>(handle.get().asCell());
    DOMWrapperWorld& world = *static_cast<DOMWrapperWorld*>(context);
    uncacheWrapper(world, &jsEventException->impl(), jsEventException);
    jsEventException->releaseImpl();
}

JSC::JSValue toJS(JSC::ExecState* exec, JSDOMGlobalObject* globalObject, EventException* impl)
{
    if (!impl)
        return jsNull();
    if (JSValue result = getExistingWrapper<JSEventException>(exec, impl))
        return result;
#if COMPILER(CLANG)
    // If you hit this failure the interface definition has the ImplementationLacksVTable
    // attribute. You should remove that attribute. If the class has subclasses
    // that may be passed through this toJS() function you should use the SkipVTableValidation
    // attribute to EventException.
    COMPILE_ASSERT(!__is_polymorphic(EventException), EventException_is_polymorphic_but_idl_claims_not_to_be);
#endif
    ReportMemoryCost<EventException>::reportMemoryCost(exec, impl);
    return createNewWrapper<JSEventException>(exec, globalObject, impl);
}

EventException* toEventException(JSC::JSValue value)
{
    return value.inherits(JSEventException::info()) ? &jsCast<JSEventException*>(value)->impl() : 0;
}

}
