/*
    This file is part of the WebKit open source project.
    This file has been generated by generate-bindings.pl. DO NOT MODIFY!

    This library is free software; you can redistribute it and/or
    modify it under the terms of the GNU Library General Public
    License as published by the Free Software Foundation; either
    version 2 of the License, or (at your option) any later version.

    This library is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
    Library General Public License for more details.

    You should have received a copy of the GNU Library General Public License
    along with this library; see the file COPYING.LIB.  If not, write to
    the Free Software Foundation, Inc., 51 Franklin Street, Fifth Floor,
    Boston, MA 02110-1301, USA.
*/

#include "config.h"
#include "JSHTMLSpanElement.h"

#include "HTMLSpanElement.h"
#include <wtf/GetPtr.h>

using namespace JSC;

namespace WebCore {

/* Hash table */

static const HashTableValue JSHTMLSpanElementTableValues[] =
{
    { "constructor", DontEnum | ReadOnly, NoIntrinsic, (intptr_t)static_cast<PropertySlot::GetValueFunc>(jsHTMLSpanElementConstructor), (intptr_t) static_cast<PutPropertySlot::PutValueFunc>(0) },
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSHTMLSpanElementTable = { 2, 1, true, JSHTMLSpanElementTableValues, 0 };
/* Hash table for constructor */

static const HashTableValue JSHTMLSpanElementConstructorTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSHTMLSpanElementConstructorTable = { 1, 0, false, JSHTMLSpanElementConstructorTableValues, 0 };
const ClassInfo JSHTMLSpanElementConstructor::s_info = { "HTMLSpanElementConstructor", &Base::s_info, &JSHTMLSpanElementConstructorTable, 0, CREATE_METHOD_TABLE(JSHTMLSpanElementConstructor) };

JSHTMLSpanElementConstructor::JSHTMLSpanElementConstructor(Structure* structure, JSDOMGlobalObject* globalObject)
    : DOMConstructorObject(structure, globalObject)
{
}

void JSHTMLSpanElementConstructor::finishCreation(VM& vm, JSDOMGlobalObject* globalObject)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
    putDirect(vm, vm.propertyNames->prototype, JSHTMLSpanElementPrototype::self(vm, globalObject), DontDelete | ReadOnly);
    putDirect(vm, vm.propertyNames->length, jsNumber(0), ReadOnly | DontDelete | DontEnum);
}

bool JSHTMLSpanElementConstructor::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    return getStaticValueSlot<JSHTMLSpanElementConstructor, JSDOMWrapper>(exec, JSHTMLSpanElementConstructorTable, jsCast<JSHTMLSpanElementConstructor*>(object), propertyName, slot);
}

/* Hash table for prototype */

static const HashTableValue JSHTMLSpanElementPrototypeTableValues[] =
{
    { 0, 0, NoIntrinsic, 0, 0 }
};

static const HashTable JSHTMLSpanElementPrototypeTable = { 1, 0, false, JSHTMLSpanElementPrototypeTableValues, 0 };
const ClassInfo JSHTMLSpanElementPrototype::s_info = { "HTMLSpanElementPrototype", &Base::s_info, &JSHTMLSpanElementPrototypeTable, 0, CREATE_METHOD_TABLE(JSHTMLSpanElementPrototype) };

JSObject* JSHTMLSpanElementPrototype::self(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMPrototype<JSHTMLSpanElement>(vm, globalObject);
}

const ClassInfo JSHTMLSpanElement::s_info = { "HTMLSpanElement", &Base::s_info, &JSHTMLSpanElementTable, 0 , CREATE_METHOD_TABLE(JSHTMLSpanElement) };

JSHTMLSpanElement::JSHTMLSpanElement(Structure* structure, JSDOMGlobalObject* globalObject, PassRefPtr<HTMLSpanElement> impl)
    : JSHTMLElement(structure, globalObject, impl)
{
}

void JSHTMLSpanElement::finishCreation(VM& vm)
{
    Base::finishCreation(vm);
    ASSERT(inherits(info()));
}

JSObject* JSHTMLSpanElement::createPrototype(VM& vm, JSGlobalObject* globalObject)
{
    return JSHTMLSpanElementPrototype::create(vm, globalObject, JSHTMLSpanElementPrototype::createStructure(vm, globalObject, JSHTMLElementPrototype::self(vm, globalObject)));
}

bool JSHTMLSpanElement::getOwnPropertySlot(JSObject* object, ExecState* exec, PropertyName propertyName, PropertySlot& slot)
{
    JSHTMLSpanElement* thisObject = jsCast<JSHTMLSpanElement*>(object);
    ASSERT_GC_OBJECT_INHERITS(thisObject, info());
    return getStaticValueSlot<JSHTMLSpanElement, Base>(exec, JSHTMLSpanElementTable, thisObject, propertyName, slot);
}

EncodedJSValue jsHTMLSpanElementConstructor(ExecState* exec, EncodedJSValue thisValue, EncodedJSValue, PropertyName)
{
    JSHTMLSpanElement* domObject = jsDynamicCast<JSHTMLSpanElement*>(JSValue::decode(thisValue));
    if (!domObject)
        return throwVMTypeError(exec);
    if (!domObject)
        return throwVMTypeError(exec);
    return JSValue::encode(JSHTMLSpanElement::getConstructor(exec->vm(), domObject->globalObject()));
}

JSValue JSHTMLSpanElement::getConstructor(VM& vm, JSGlobalObject* globalObject)
{
    return getDOMConstructor<JSHTMLSpanElementConstructor>(vm, jsCast<JSDOMGlobalObject*>(globalObject));
}


}
